package eu.dnetlib.dhp.schema.oaf;

import static org.junit.jupiter.api.Assertions.*;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;

public class RelationTest {

    @Test
    public void checkExistRelType() {
        assertTrue(Relation.SUBRELTYPE.exists(Relation.SUBRELTYPE.dedup.toString()));
        assertFalse(Relation.SUBRELTYPE.exists("foo"));

    }
    @Test
    public void checkSubRelType() {
        Relation.RELCLASS rc = Relation.RELCLASS.merges;
        assertEquals(Relation.SUBRELTYPE.dedup, rc.getSubRel());

        for (Relation.RELCLASS value : Relation.RELCLASS.values()) {
            System.out.printf("%s  => %s\n", value, value.getSubRel());

        }
    }

    @Test
    public void lookRelClassUpTest() {
        Assertions.assertEquals(Relation.RELCLASS.Compiles, Relation.RELCLASS.lookUp("compiles"));
        Assertions.assertEquals(Relation.RELCLASS.IsMetadataFor, Relation.RELCLASS.lookUp("isMetaDATAFOr"));
        Assertions.assertThrows(IllegalArgumentException.class, () -> Relation.RELCLASS.lookUp("hello"));
    }

}
